package com.toughra.ustadmobile.databinding;
import com.toughra.ustadmobile.R;
import com.toughra.ustadmobile.BR;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import android.view.View;
@SuppressWarnings("unchecked")
public class FragmentDateRangeBindingImpl extends FragmentDateRangeBinding implements com.toughra.ustadmobile.generated.callback.OnClickListener.Listener {

    @Nullable
    private static final androidx.databinding.ViewDataBinding.IncludedLayouts sIncludes;
    @Nullable
    private static final android.util.SparseIntArray sViewsWithIds;
    static {
        sIncludes = null;
        sViewsWithIds = new android.util.SparseIntArray();
        sViewsWithIds.put(R.id.fragment_date_range_edit_clx, 23);
        sViewsWithIds.put(R.id.date_range_fromLabel, 24);
        sViewsWithIds.put(R.id.date_range_toLabel, 25);
    }
    // views
    @NonNull
    private final android.widget.TextView mboundView18;
    @NonNull
    private final android.widget.TextView mboundView7;
    // variables
    @Nullable
    private final android.view.View.OnClickListener mCallback99;
    @Nullable
    private final android.view.View.OnClickListener mCallback96;
    @Nullable
    private final android.view.View.OnClickListener mCallback98;
    @Nullable
    private final android.view.View.OnClickListener mCallback97;
    // values
    // listeners
    // Inverse Binding Event Handlers
    private androidx.databinding.InverseBindingListener fragmentDateRangeFixedDateFromDateTextViewdateTimeInMillisAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of dateRangeMoment.fromMoment.fixedTime
            //         is dateRangeMoment.fromMoment.setFixedTime((long) callbackArg_0)
            long callbackArg_0 = com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.getDateTimeInMillis(fragmentDateRangeFixedDateFromDateTextView);
            // localize variables for thread safety
            // dateRangeMoment.fromMoment
            com.ustadmobile.lib.db.entities.Moment dateRangeMomentFromMoment = null;
            // dateRangeMoment
            com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
            // dateRangeMoment.fromMoment.fixedTime
            long dateRangeMomentFromMomentFixedTime = 0;
            // dateRangeMoment.fromMoment != null
            boolean dateRangeMomentFromMomentJavaLangObjectNull = false;
            // dateRangeMoment != null
            boolean dateRangeMomentJavaLangObjectNull = false;



            dateRangeMomentJavaLangObjectNull = (dateRangeMoment) != (null);
            if (dateRangeMomentJavaLangObjectNull) {


                dateRangeMomentFromMoment = dateRangeMoment.getFromMoment();

                dateRangeMomentFromMomentJavaLangObjectNull = (dateRangeMomentFromMoment) != (null);
                if (dateRangeMomentFromMomentJavaLangObjectNull) {




                    dateRangeMomentFromMoment.setFixedTime(((long) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener fragmentDateRangeFixedDateToDateTextViewdateTimeInMillisAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of dateRangeMoment.toMoment.fixedTime
            //         is dateRangeMoment.toMoment.setFixedTime((long) callbackArg_0)
            long callbackArg_0 = com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.getDateTimeInMillis(fragmentDateRangeFixedDateToDateTextView);
            // localize variables for thread safety
            // dateRangeMoment.toMoment != null
            boolean dateRangeMomentToMomentJavaLangObjectNull = false;
            // dateRangeMoment
            com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
            // dateRangeMoment.toMoment.fixedTime
            long dateRangeMomentToMomentFixedTime = 0;
            // dateRangeMoment != null
            boolean dateRangeMomentJavaLangObjectNull = false;
            // dateRangeMoment.toMoment
            com.ustadmobile.lib.db.entities.Moment dateRangeMomentToMoment = null;



            dateRangeMomentJavaLangObjectNull = (dateRangeMoment) != (null);
            if (dateRangeMomentJavaLangObjectNull) {


                dateRangeMomentToMoment = dateRangeMoment.getToMoment();

                dateRangeMomentToMomentJavaLangObjectNull = (dateRangeMomentToMoment) != (null);
                if (dateRangeMomentToMomentJavaLangObjectNull) {




                    dateRangeMomentToMoment.setFixedTime(((long) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener fragmentDateRangeFromDateRangeEditTextandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of ("") + (-dateRangeMoment.fromMoment.relOffSet)
            //         is dateRangeMoment.fromMoment.setRelOffSet((int) -androidx.databinding.ViewDataBinding.parse(callbackArg_0, -dateRangeMoment.fromMoment.relOffSet))
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(fragmentDateRangeFromDateRangeEditText);
            // localize variables for thread safety
            // dateRangeMoment.fromMoment
            com.ustadmobile.lib.db.entities.Moment dateRangeMomentFromMoment = null;
            // androidx.databinding.ViewDataBinding.parse(callbackArg_0, -dateRangeMoment.fromMoment.relOffSet)
            int androidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet = 0;
            // dateRangeMoment
            com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
            // dateRangeMoment.fromMoment != null
            boolean dateRangeMomentFromMomentJavaLangObjectNull = false;
            // -androidx.databinding.ViewDataBinding.parse(callbackArg_0, -dateRangeMoment.fromMoment.relOffSet)
            int AndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet1 = 0;
            // dateRangeMoment != null
            boolean dateRangeMomentJavaLangObjectNull = false;
            // (int) -androidx.databinding.ViewDataBinding.parse(callbackArg_0, -dateRangeMoment.fromMoment.relOffSet)
            int intAndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet = 0;
            // ("") + (-dateRangeMoment.fromMoment.relOffSet)
            java.lang.String javaLangStringDateRangeMomentFromMomentRelOffSet = null;
            // dateRangeMoment.fromMoment.relOffSet
            int dateRangeMomentFromMomentRelOffSet = 0;
            // -dateRangeMoment.fromMoment.relOffSet
            int DateRangeMomentFromMomentRelOffSet1 = 0;



            dateRangeMomentJavaLangObjectNull = (dateRangeMoment) != (null);
            if (dateRangeMomentJavaLangObjectNull) {


                dateRangeMomentFromMoment = dateRangeMoment.getFromMoment();

                dateRangeMomentFromMomentJavaLangObjectNull = (dateRangeMomentFromMoment) != (null);
                if (dateRangeMomentFromMomentJavaLangObjectNull) {






                    dateRangeMomentFromMomentRelOffSet = dateRangeMomentFromMoment.getRelOffSet();

                    DateRangeMomentFromMomentRelOffSet1 = -dateRangeMomentFromMomentRelOffSet;

                    androidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet = androidx.databinding.ViewDataBinding.parse(callbackArg_0, DateRangeMomentFromMomentRelOffSet1);

                    AndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet1 = -androidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet;

                    intAndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet = ((int) (AndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet1));

                    dateRangeMomentFromMoment.setRelOffSet(intAndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentFromMomentRelOffSet);
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener fragmentDateRangeRelativeDateFromDateRelTextViewselectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of dateRangeMoment.fromMoment.relTo
            //         is dateRangeMoment.fromMoment.setRelTo((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(fragmentDateRangeRelativeDateFromDateRelTextView);
            // localize variables for thread safety
            // dateRangeMoment.fromMoment
            com.ustadmobile.lib.db.entities.Moment dateRangeMomentFromMoment = null;
            // dateRangeMoment.fromMoment.relTo
            int dateRangeMomentFromMomentRelTo = 0;
            // dateRangeMoment
            com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
            // dateRangeMoment.fromMoment != null
            boolean dateRangeMomentFromMomentJavaLangObjectNull = false;
            // dateRangeMoment != null
            boolean dateRangeMomentJavaLangObjectNull = false;



            dateRangeMomentJavaLangObjectNull = (dateRangeMoment) != (null);
            if (dateRangeMomentJavaLangObjectNull) {


                dateRangeMomentFromMoment = dateRangeMoment.getFromMoment();

                dateRangeMomentFromMomentJavaLangObjectNull = (dateRangeMomentFromMoment) != (null);
                if (dateRangeMomentFromMomentJavaLangObjectNull) {




                    dateRangeMomentFromMoment.setRelTo(((int) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener fragmentDateRangeRelativeDateFromDateRelUnitTextViewselectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of dateRangeMoment.fromMoment.relUnit
            //         is dateRangeMoment.fromMoment.setRelUnit((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(fragmentDateRangeRelativeDateFromDateRelUnitTextView);
            // localize variables for thread safety
            // dateRangeMoment.fromMoment
            com.ustadmobile.lib.db.entities.Moment dateRangeMomentFromMoment = null;
            // dateRangeMoment.fromMoment.relUnit
            int dateRangeMomentFromMomentRelUnit = 0;
            // dateRangeMoment
            com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
            // dateRangeMoment.fromMoment != null
            boolean dateRangeMomentFromMomentJavaLangObjectNull = false;
            // dateRangeMoment != null
            boolean dateRangeMomentJavaLangObjectNull = false;



            dateRangeMomentJavaLangObjectNull = (dateRangeMoment) != (null);
            if (dateRangeMomentJavaLangObjectNull) {


                dateRangeMomentFromMoment = dateRangeMoment.getFromMoment();

                dateRangeMomentFromMomentJavaLangObjectNull = (dateRangeMomentFromMoment) != (null);
                if (dateRangeMomentFromMomentJavaLangObjectNull) {




                    dateRangeMomentFromMoment.setRelUnit(((int) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener fragmentDateRangeRelativeDateToDateRelTextViewselectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of dateRangeMoment.toMoment.relTo
            //         is dateRangeMoment.toMoment.setRelTo((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(fragmentDateRangeRelativeDateToDateRelTextView);
            // localize variables for thread safety
            // dateRangeMoment.toMoment != null
            boolean dateRangeMomentToMomentJavaLangObjectNull = false;
            // dateRangeMoment.toMoment.relTo
            int dateRangeMomentToMomentRelTo = 0;
            // dateRangeMoment
            com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
            // dateRangeMoment != null
            boolean dateRangeMomentJavaLangObjectNull = false;
            // dateRangeMoment.toMoment
            com.ustadmobile.lib.db.entities.Moment dateRangeMomentToMoment = null;



            dateRangeMomentJavaLangObjectNull = (dateRangeMoment) != (null);
            if (dateRangeMomentJavaLangObjectNull) {


                dateRangeMomentToMoment = dateRangeMoment.getToMoment();

                dateRangeMomentToMomentJavaLangObjectNull = (dateRangeMomentToMoment) != (null);
                if (dateRangeMomentToMomentJavaLangObjectNull) {




                    dateRangeMomentToMoment.setRelTo(((int) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener fragmentDateRangeRelativeDateToDateRelUnitTextViewselectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of dateRangeMoment.toMoment.relUnit
            //         is dateRangeMoment.toMoment.setRelUnit((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(fragmentDateRangeRelativeDateToDateRelUnitTextView);
            // localize variables for thread safety
            // dateRangeMoment.toMoment != null
            boolean dateRangeMomentToMomentJavaLangObjectNull = false;
            // dateRangeMoment
            com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
            // dateRangeMoment != null
            boolean dateRangeMomentJavaLangObjectNull = false;
            // dateRangeMoment.toMoment
            com.ustadmobile.lib.db.entities.Moment dateRangeMomentToMoment = null;
            // dateRangeMoment.toMoment.relUnit
            int dateRangeMomentToMomentRelUnit = 0;



            dateRangeMomentJavaLangObjectNull = (dateRangeMoment) != (null);
            if (dateRangeMomentJavaLangObjectNull) {


                dateRangeMomentToMoment = dateRangeMoment.getToMoment();

                dateRangeMomentToMomentJavaLangObjectNull = (dateRangeMomentToMoment) != (null);
                if (dateRangeMomentToMomentJavaLangObjectNull) {




                    dateRangeMomentToMoment.setRelUnit(((int) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener fragmentDateRangeToDateRangeEditTextandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of ("") + (-dateRangeMoment.toMoment.relOffSet)
            //         is dateRangeMoment.toMoment.setRelOffSet((int) -androidx.databinding.ViewDataBinding.parse(callbackArg_0, -dateRangeMoment.toMoment.relOffSet))
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(fragmentDateRangeToDateRangeEditText);
            // localize variables for thread safety
            // -androidx.databinding.ViewDataBinding.parse(callbackArg_0, -dateRangeMoment.toMoment.relOffSet)
            int androidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet = 0;
            // dateRangeMoment.toMoment != null
            boolean dateRangeMomentToMomentJavaLangObjectNull = false;
            // dateRangeMoment
            com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
            // -dateRangeMoment.toMoment.relOffSet
            int dateRangeMomentToMomentRelOffSet = 0;
            // dateRangeMoment != null
            boolean dateRangeMomentJavaLangObjectNull = false;
            // dateRangeMoment.toMoment
            com.ustadmobile.lib.db.entities.Moment dateRangeMomentToMoment = null;
            // ("") + (-dateRangeMoment.toMoment.relOffSet)
            java.lang.String javaLangStringDateRangeMomentToMomentRelOffSet = null;
            // dateRangeMoment.toMoment.relOffSet
            int DateRangeMomentToMomentRelOffSet1 = 0;
            // (int) -androidx.databinding.ViewDataBinding.parse(callbackArg_0, -dateRangeMoment.toMoment.relOffSet)
            int intAndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet = 0;
            // androidx.databinding.ViewDataBinding.parse(callbackArg_0, -dateRangeMoment.toMoment.relOffSet)
            int AndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet1 = 0;



            dateRangeMomentJavaLangObjectNull = (dateRangeMoment) != (null);
            if (dateRangeMomentJavaLangObjectNull) {


                dateRangeMomentToMoment = dateRangeMoment.getToMoment();

                dateRangeMomentToMomentJavaLangObjectNull = (dateRangeMomentToMoment) != (null);
                if (dateRangeMomentToMomentJavaLangObjectNull) {






                    DateRangeMomentToMomentRelOffSet1 = dateRangeMomentToMoment.getRelOffSet();

                    dateRangeMomentToMomentRelOffSet = -DateRangeMomentToMomentRelOffSet1;

                    AndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet1 = androidx.databinding.ViewDataBinding.parse(callbackArg_0, dateRangeMomentToMomentRelOffSet);

                    androidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet = -AndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet1;

                    intAndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet = ((int) (androidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet));

                    dateRangeMomentToMoment.setRelOffSet(intAndroidxDatabindingViewDataBindingParseCallbackArg0DateRangeMomentToMomentRelOffSet);
                }
            }
        }
    };

    public FragmentDateRangeBindingImpl(@Nullable androidx.databinding.DataBindingComponent bindingComponent, @NonNull View root) {
        this(bindingComponent, root, mapBindings(bindingComponent, root, 26, sIncludes, sViewsWithIds));
    }
    private FragmentDateRangeBindingImpl(androidx.databinding.DataBindingComponent bindingComponent, View root, Object[] bindings) {
        super(bindingComponent, root, 0
            , (android.widget.TextView) bindings[24]
            , (android.widget.RadioButton) bindings[1]
            , (android.widget.RadioButton) bindings[4]
            , (android.widget.TextView) bindings[25]
            , (android.widget.RadioButton) bindings[12]
            , (android.widget.RadioButton) bindings[15]
            , (androidx.constraintlayout.widget.ConstraintLayout) bindings[23]
            , (androidx.core.widget.NestedScrollView) bindings[0]
            , (com.google.android.material.textfield.TextInputLayout) bindings[2]
            , (com.google.android.material.textfield.TextInputEditText) bindings[3]
            , (com.google.android.material.textfield.TextInputLayout) bindings[13]
            , (com.google.android.material.textfield.TextInputEditText) bindings[14]
            , (com.google.android.material.textfield.TextInputEditText) bindings[9]
            , (com.google.android.material.textfield.TextInputLayout) bindings[8]
            , (com.google.android.material.textfield.TextInputLayout) bindings[5]
            , (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[6]
            , (com.google.android.material.textfield.TextInputLayout) bindings[10]
            , (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[11]
            , (com.google.android.material.textfield.TextInputLayout) bindings[16]
            , (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[17]
            , (com.google.android.material.textfield.TextInputLayout) bindings[21]
            , (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[22]
            , (com.google.android.material.textfield.TextInputEditText) bindings[20]
            , (com.google.android.material.textfield.TextInputLayout) bindings[19]
            );
        this.dateRangeFromRadioFixedDate.setTag(null);
        this.dateRangeFromRadioRelativeDate.setTag(null);
        this.dateRangeToRadioFixedDate.setTag(null);
        this.dateRangeToRadioRelativeDate.setTag(null);
        this.fragmentDateRangeEditScroll.setTag(null);
        this.fragmentDateRangeFixedDateFromDateTextInputLayout.setTag(null);
        this.fragmentDateRangeFixedDateFromDateTextView.setTag(null);
        this.fragmentDateRangeFixedDateToDateTextInputLayout.setTag(null);
        this.fragmentDateRangeFixedDateToDateTextView.setTag(null);
        this.fragmentDateRangeFromDateRangeEditText.setTag(null);
        this.fragmentDateRangeFromDateRangeInputLayout.setTag(null);
        this.fragmentDateRangeRelativeDateFromDateRelTextInputLayout.setTag(null);
        this.fragmentDateRangeRelativeDateFromDateRelTextView.setTag(null);
        this.fragmentDateRangeRelativeDateFromDateRelUnitTextInputLayout.setTag(null);
        this.fragmentDateRangeRelativeDateFromDateRelUnitTextView.setTag(null);
        this.fragmentDateRangeRelativeDateToDateRelTextInputLayout.setTag(null);
        this.fragmentDateRangeRelativeDateToDateRelTextView.setTag(null);
        this.fragmentDateRangeRelativeDateToDateRelUnitTextInputLayout.setTag(null);
        this.fragmentDateRangeRelativeDateToDateRelUnitTextView.setTag(null);
        this.fragmentDateRangeToDateRangeEditText.setTag(null);
        this.fragmentDateRangeToDateRangeInputLayout.setTag(null);
        this.mboundView18 = (android.widget.TextView) bindings[18];
        this.mboundView18.setTag(null);
        this.mboundView7 = (android.widget.TextView) bindings[7];
        this.mboundView7.setTag(null);
        setRootTag(root);
        // listeners
        mCallback99 = new com.toughra.ustadmobile.generated.callback.OnClickListener(this, 4);
        mCallback96 = new com.toughra.ustadmobile.generated.callback.OnClickListener(this, 1);
        mCallback98 = new com.toughra.ustadmobile.generated.callback.OnClickListener(this, 3);
        mCallback97 = new com.toughra.ustadmobile.generated.callback.OnClickListener(this, 2);
        invalidateAll();
    }

    @Override
    public void invalidateAll() {
        synchronized(this) {
                mDirtyFlags = 0x800L;
        }
        requestRebind();
    }

    @Override
    public boolean hasPendingBindings() {
        synchronized(this) {
            if (mDirtyFlags != 0) {
                return true;
            }
        }
        return false;
    }

    @Override
    public boolean setVariable(int variableId, @Nullable Object variable)  {
        boolean variableSet = true;
        if (BR.dateRangeMoment == variableId) {
            setDateRangeMoment((com.ustadmobile.lib.db.entities.DateRangeMoment) variable);
        }
        else if (BR.toRelativeDateInvalid == variableId) {
            setToRelativeDateInvalid((java.lang.String) variable);
        }
        else if (BR.fromFixedDateMissing == variableId) {
            setFromFixedDateMissing((java.lang.String) variable);
        }
        else if (BR.relToOptions == variableId) {
            setRelToOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.loading == variableId) {
            setLoading((boolean) variable);
        }
        else if (BR.relUnitOption == variableId) {
            setRelUnitOption((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.activityEventHandler == variableId) {
            setActivityEventHandler((com.ustadmobile.port.android.view.DateRangeFragmentEventHandler) variable);
        }
        else if (BR.toFixedDateMissing == variableId) {
            setToFixedDateMissing((java.lang.String) variable);
        }
        else if (BR.fieldsEnabled == variableId) {
            setFieldsEnabled((boolean) variable);
        }
        else if (BR.dateTimeMode == variableId) {
            setDateTimeMode((java.lang.Integer) variable);
        }
        else if (BR.timeZoneId == variableId) {
            setTimeZoneId((java.lang.String) variable);
        }
        else {
            variableSet = false;
        }
            return variableSet;
    }

    public void setDateRangeMoment(@Nullable com.ustadmobile.lib.db.entities.DateRangeMoment DateRangeMoment) {
        this.mDateRangeMoment = DateRangeMoment;
        synchronized(this) {
            mDirtyFlags |= 0x1L;
        }
        notifyPropertyChanged(BR.dateRangeMoment);
        super.requestRebind();
    }
    public void setToRelativeDateInvalid(@Nullable java.lang.String ToRelativeDateInvalid) {
        this.mToRelativeDateInvalid = ToRelativeDateInvalid;
        synchronized(this) {
            mDirtyFlags |= 0x2L;
        }
        notifyPropertyChanged(BR.toRelativeDateInvalid);
        super.requestRebind();
    }
    public void setFromFixedDateMissing(@Nullable java.lang.String FromFixedDateMissing) {
        this.mFromFixedDateMissing = FromFixedDateMissing;
        synchronized(this) {
            mDirtyFlags |= 0x4L;
        }
        notifyPropertyChanged(BR.fromFixedDateMissing);
        super.requestRebind();
    }
    public void setRelToOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> RelToOptions) {
        this.mRelToOptions = RelToOptions;
        synchronized(this) {
            mDirtyFlags |= 0x8L;
        }
        notifyPropertyChanged(BR.relToOptions);
        super.requestRebind();
    }
    public void setLoading(boolean Loading) {
        this.mLoading = Loading;
    }
    public void setRelUnitOption(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> RelUnitOption) {
        this.mRelUnitOption = RelUnitOption;
        synchronized(this) {
            mDirtyFlags |= 0x20L;
        }
        notifyPropertyChanged(BR.relUnitOption);
        super.requestRebind();
    }
    public void setActivityEventHandler(@Nullable com.ustadmobile.port.android.view.DateRangeFragmentEventHandler ActivityEventHandler) {
        this.mActivityEventHandler = ActivityEventHandler;
        synchronized(this) {
            mDirtyFlags |= 0x40L;
        }
        notifyPropertyChanged(BR.activityEventHandler);
        super.requestRebind();
    }
    public void setToFixedDateMissing(@Nullable java.lang.String ToFixedDateMissing) {
        this.mToFixedDateMissing = ToFixedDateMissing;
        synchronized(this) {
            mDirtyFlags |= 0x80L;
        }
        notifyPropertyChanged(BR.toFixedDateMissing);
        super.requestRebind();
    }
    public void setFieldsEnabled(boolean FieldsEnabled) {
        this.mFieldsEnabled = FieldsEnabled;
    }
    public void setDateTimeMode(@Nullable java.lang.Integer DateTimeMode) {
        this.mDateTimeMode = DateTimeMode;
        synchronized(this) {
            mDirtyFlags |= 0x200L;
        }
        notifyPropertyChanged(BR.dateTimeMode);
        super.requestRebind();
    }
    public void setTimeZoneId(@Nullable java.lang.String TimeZoneId) {
        this.mTimeZoneId = TimeZoneId;
        synchronized(this) {
            mDirtyFlags |= 0x400L;
        }
        notifyPropertyChanged(BR.timeZoneId);
        super.requestRebind();
    }

    @Override
    protected boolean onFieldChange(int localFieldId, Object object, int fieldId) {
        switch (localFieldId) {
        }
        return false;
    }

    @Override
    protected void executeBindings() {
        long dirtyFlags = 0;
        synchronized(this) {
            dirtyFlags = mDirtyFlags;
            mDirtyFlags = 0;
        }
        boolean toFixedDateMissingJavaLangObjectNull = false;
        boolean dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVE = false;
        int dateRangeMomentToMomentRelOffSet = 0;
        boolean toRelativeDateInvalidJavaLangObjectNull = false;
        int dateRangeMomentFromMomentRelUnit = 0;
        int dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGFIXEDViewVISIBLEViewGONE = 0;
        com.ustadmobile.lib.db.entities.DateRangeMoment dateRangeMoment = mDateRangeMoment;
        boolean dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVE = false;
        com.ustadmobile.lib.db.entities.Moment dateRangeMomentToMoment = null;
        boolean dateRangeMomentToMomentTypeFlagMomentTYPEFLAGFIXED = false;
        int dateRangeMomentToMomentRelUnit = 0;
        java.lang.String javaLangStringDateRangeMomentToMomentRelOffSet = null;
        java.lang.String javaLangStringDateRangeMomentFromMomentRelOffSet = null;
        java.lang.String toRelativeDateInvalid = mToRelativeDateInvalid;
        java.lang.String fromFixedDateMissing = mFromFixedDateMissing;
        java.util.List<com.ustadmobile.core.util.IdOption> relToOptions = mRelToOptions;
        int dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE = 0;
        int dateRangeMomentFromMomentTypeFlag = 0;
        boolean dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGFIXED = false;
        java.util.List<com.ustadmobile.core.util.IdOption> relUnitOption = mRelUnitOption;
        int DateRangeMomentToMomentRelOffSet1 = 0;
        com.ustadmobile.port.android.view.DateRangeFragmentEventHandler activityEventHandler = mActivityEventHandler;
        long dateRangeMomentFromMomentFixedTime = 0;
        java.lang.String toFixedDateMissing = mToFixedDateMissing;
        com.ustadmobile.lib.db.entities.Moment dateRangeMomentFromMoment = null;
        int dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE = 0;
        int dateRangeMomentFromMomentRelTo = 0;
        int dateRangeMomentToMomentRelTo = 0;
        int dateRangeMomentToMomentTypeFlag = 0;
        int dateRangeMomentToMomentTypeFlagMomentTYPEFLAGFIXEDViewVISIBLEViewGONE = 0;
        boolean fromFixedDateMissingJavaLangObjectNull = false;
        int androidxDatabindingViewDataBindingSafeUnboxDateTimeMode = 0;
        java.lang.Integer dateTimeMode = mDateTimeMode;
        java.lang.String timeZoneId = mTimeZoneId;
        int dateRangeMomentFromMomentRelOffSet = 0;
        long dateRangeMomentToMomentFixedTime = 0;
        int DateRangeMomentFromMomentRelOffSet1 = 0;

        if ((dirtyFlags & 0xe29L) != 0) {



                if (dateRangeMoment != null) {
                    // read dateRangeMoment.toMoment
                    dateRangeMomentToMoment = dateRangeMoment.getToMoment();
                    // read dateRangeMoment.fromMoment
                    dateRangeMomentFromMoment = dateRangeMoment.getFromMoment();
                }

            if ((dirtyFlags & 0x801L) != 0) {

                    if (dateRangeMomentToMoment != null) {
                        // read dateRangeMoment.toMoment.relOffSet
                        dateRangeMomentToMomentRelOffSet = dateRangeMomentToMoment.getRelOffSet();
                        // read dateRangeMoment.toMoment.typeFlag
                        dateRangeMomentToMomentTypeFlag = dateRangeMomentToMoment.getTypeFlag();
                    }
                    if (dateRangeMomentFromMoment != null) {
                        // read dateRangeMoment.fromMoment.typeFlag
                        dateRangeMomentFromMomentTypeFlag = dateRangeMomentFromMoment.getTypeFlag();
                        // read dateRangeMoment.fromMoment.relOffSet
                        dateRangeMomentFromMomentRelOffSet = dateRangeMomentFromMoment.getRelOffSet();
                    }


                    // read -dateRangeMoment.toMoment.relOffSet
                    DateRangeMomentToMomentRelOffSet1 = -dateRangeMomentToMomentRelOffSet;
                    // read dateRangeMoment.toMoment.typeFlag == Moment.TYPE_FLAG_RELATIVE
                    dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVE = (dateRangeMomentToMomentTypeFlag) == (com.ustadmobile.lib.db.entities.Moment.TYPE_FLAG_RELATIVE);
                    // read dateRangeMoment.toMoment.typeFlag == Moment.TYPE_FLAG_FIXED
                    dateRangeMomentToMomentTypeFlagMomentTYPEFLAGFIXED = (dateRangeMomentToMomentTypeFlag) == (com.ustadmobile.lib.db.entities.Moment.TYPE_FLAG_FIXED);
                    // read dateRangeMoment.fromMoment.typeFlag == Moment.TYPE_FLAG_RELATIVE
                    dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVE = (dateRangeMomentFromMomentTypeFlag) == (com.ustadmobile.lib.db.entities.Moment.TYPE_FLAG_RELATIVE);
                    // read dateRangeMoment.fromMoment.typeFlag == Moment.TYPE_FLAG_FIXED
                    dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGFIXED = (dateRangeMomentFromMomentTypeFlag) == (com.ustadmobile.lib.db.entities.Moment.TYPE_FLAG_FIXED);
                    // read -dateRangeMoment.fromMoment.relOffSet
                    DateRangeMomentFromMomentRelOffSet1 = -dateRangeMomentFromMomentRelOffSet;
                if((dirtyFlags & 0x801L) != 0) {
                    if(dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVE) {
                            dirtyFlags |= 0x20000L;
                    }
                    else {
                            dirtyFlags |= 0x10000L;
                    }
                }
                if((dirtyFlags & 0x801L) != 0) {
                    if(dateRangeMomentToMomentTypeFlagMomentTYPEFLAGFIXED) {
                            dirtyFlags |= 0x80000L;
                    }
                    else {
                            dirtyFlags |= 0x40000L;
                    }
                }
                if((dirtyFlags & 0x801L) != 0) {
                    if(dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVE) {
                            dirtyFlags |= 0x8000L;
                    }
                    else {
                            dirtyFlags |= 0x4000L;
                    }
                }
                if((dirtyFlags & 0x801L) != 0) {
                    if(dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGFIXED) {
                            dirtyFlags |= 0x2000L;
                    }
                    else {
                            dirtyFlags |= 0x1000L;
                    }
                }


                    // read ("") + (-dateRangeMoment.toMoment.relOffSet)
                    javaLangStringDateRangeMomentToMomentRelOffSet = ("") + (DateRangeMomentToMomentRelOffSet1);
                    // read dateRangeMoment.toMoment.typeFlag == Moment.TYPE_FLAG_RELATIVE ? View.VISIBLE : View.GONE
                    dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE = ((dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVE) ? (android.view.View.VISIBLE) : (android.view.View.GONE));
                    // read dateRangeMoment.toMoment.typeFlag == Moment.TYPE_FLAG_FIXED ? View.VISIBLE : View.GONE
                    dateRangeMomentToMomentTypeFlagMomentTYPEFLAGFIXEDViewVISIBLEViewGONE = ((dateRangeMomentToMomentTypeFlagMomentTYPEFLAGFIXED) ? (android.view.View.VISIBLE) : (android.view.View.GONE));
                    // read dateRangeMoment.fromMoment.typeFlag == Moment.TYPE_FLAG_RELATIVE ? View.VISIBLE : View.GONE
                    dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE = ((dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVE) ? (android.view.View.VISIBLE) : (android.view.View.GONE));
                    // read dateRangeMoment.fromMoment.typeFlag == Moment.TYPE_FLAG_FIXED ? View.VISIBLE : View.GONE
                    dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGFIXEDViewVISIBLEViewGONE = ((dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGFIXED) ? (android.view.View.VISIBLE) : (android.view.View.GONE));
                    // read ("") + (-dateRangeMoment.fromMoment.relOffSet)
                    javaLangStringDateRangeMomentFromMomentRelOffSet = ("") + (DateRangeMomentFromMomentRelOffSet1);
            }
            if ((dirtyFlags & 0x821L) != 0) {

                    if (dateRangeMomentToMoment != null) {
                        // read dateRangeMoment.toMoment.relUnit
                        dateRangeMomentToMomentRelUnit = dateRangeMomentToMoment.getRelUnit();
                    }
                    if (dateRangeMomentFromMoment != null) {
                        // read dateRangeMoment.fromMoment.relUnit
                        dateRangeMomentFromMomentRelUnit = dateRangeMomentFromMoment.getRelUnit();
                    }
            }
            if ((dirtyFlags & 0x809L) != 0) {

                    if (dateRangeMomentToMoment != null) {
                        // read dateRangeMoment.toMoment.relTo
                        dateRangeMomentToMomentRelTo = dateRangeMomentToMoment.getRelTo();
                    }
                    if (dateRangeMomentFromMoment != null) {
                        // read dateRangeMoment.fromMoment.relTo
                        dateRangeMomentFromMomentRelTo = dateRangeMomentFromMoment.getRelTo();
                    }
            }
            if ((dirtyFlags & 0xe01L) != 0) {

                    if (dateRangeMomentToMoment != null) {
                        // read dateRangeMoment.toMoment.fixedTime
                        dateRangeMomentToMomentFixedTime = dateRangeMomentToMoment.getFixedTime();
                    }
                    if (dateRangeMomentFromMoment != null) {
                        // read dateRangeMoment.fromMoment.fixedTime
                        dateRangeMomentFromMomentFixedTime = dateRangeMomentFromMoment.getFixedTime();
                    }
            }
        }
        if ((dirtyFlags & 0x802L) != 0) {



                // read toRelativeDateInvalid != null
                toRelativeDateInvalidJavaLangObjectNull = (toRelativeDateInvalid) != (null);
        }
        if ((dirtyFlags & 0x804L) != 0) {



                // read fromFixedDateMissing != null
                fromFixedDateMissingJavaLangObjectNull = (fromFixedDateMissing) != (null);
        }
        if ((dirtyFlags & 0x809L) != 0) {
        }
        if ((dirtyFlags & 0x821L) != 0) {
        }
        if ((dirtyFlags & 0x880L) != 0) {



                // read toFixedDateMissing != null
                toFixedDateMissingJavaLangObjectNull = (toFixedDateMissing) != (null);
        }
        if ((dirtyFlags & 0xe01L) != 0) {



                // read androidx.databinding.ViewDataBinding.safeUnbox(dateTimeMode)
                androidxDatabindingViewDataBindingSafeUnboxDateTimeMode = androidx.databinding.ViewDataBinding.safeUnbox(dateTimeMode);
        }
        // batch finished
        if ((dirtyFlags & 0x801L) != 0) {
            // api target 1

            androidx.databinding.adapters.CompoundButtonBindingAdapter.setChecked(this.dateRangeFromRadioFixedDate, dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGFIXED);
            androidx.databinding.adapters.CompoundButtonBindingAdapter.setChecked(this.dateRangeFromRadioRelativeDate, dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVE);
            androidx.databinding.adapters.CompoundButtonBindingAdapter.setChecked(this.dateRangeToRadioFixedDate, dateRangeMomentToMomentTypeFlagMomentTYPEFLAGFIXED);
            androidx.databinding.adapters.CompoundButtonBindingAdapter.setChecked(this.dateRangeToRadioRelativeDate, dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVE);
            this.fragmentDateRangeFixedDateFromDateTextInputLayout.setVisibility(dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGFIXEDViewVISIBLEViewGONE);
            this.fragmentDateRangeFixedDateToDateTextInputLayout.setVisibility(dateRangeMomentToMomentTypeFlagMomentTYPEFLAGFIXEDViewVISIBLEViewGONE);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.fragmentDateRangeFromDateRangeEditText, javaLangStringDateRangeMomentFromMomentRelOffSet);
            this.fragmentDateRangeFromDateRangeInputLayout.setVisibility(dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE);
            this.fragmentDateRangeRelativeDateFromDateRelTextInputLayout.setVisibility(dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE);
            this.fragmentDateRangeRelativeDateFromDateRelUnitTextInputLayout.setVisibility(dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE);
            this.fragmentDateRangeRelativeDateToDateRelTextInputLayout.setVisibility(dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE);
            this.fragmentDateRangeRelativeDateToDateRelUnitTextInputLayout.setVisibility(dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.fragmentDateRangeToDateRangeEditText, javaLangStringDateRangeMomentToMomentRelOffSet);
            this.fragmentDateRangeToDateRangeInputLayout.setVisibility(dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE);
            this.mboundView18.setVisibility(dateRangeMomentToMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE);
            this.mboundView7.setVisibility(dateRangeMomentFromMomentTypeFlagMomentTYPEFLAGRELATIVEViewVISIBLEViewGONE);
        }
        if ((dirtyFlags & 0x800L) != 0) {
            // api target 1

            this.dateRangeFromRadioFixedDate.setOnClickListener(mCallback96);
            this.dateRangeFromRadioRelativeDate.setOnClickListener(mCallback97);
            this.dateRangeToRadioFixedDate.setOnClickListener(mCallback98);
            this.dateRangeToRadioRelativeDate.setOnClickListener(mCallback99);
            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTimeInMillisChanged(this.fragmentDateRangeFixedDateFromDateTextView, fragmentDateRangeFixedDateFromDateTextViewdateTimeInMillisAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.fragmentDateRangeFixedDateFromDateTextView, true);
            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTimeInMillisChanged(this.fragmentDateRangeFixedDateToDateTextView, fragmentDateRangeFixedDateToDateTextViewdateTimeInMillisAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.fragmentDateRangeFixedDateToDateTextView, true);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.fragmentDateRangeFromDateRangeEditText, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, fragmentDateRangeFromDateRangeEditTextandroidTextAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.fragmentDateRangeRelativeDateFromDateRelTextView, fragmentDateRangeRelativeDateFromDateRelTextViewselectedMessageIdOptionAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.fragmentDateRangeRelativeDateFromDateRelUnitTextView, fragmentDateRangeRelativeDateFromDateRelUnitTextViewselectedMessageIdOptionAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.fragmentDateRangeRelativeDateToDateRelTextView, fragmentDateRangeRelativeDateToDateRelTextViewselectedMessageIdOptionAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.fragmentDateRangeRelativeDateToDateRelUnitTextView, fragmentDateRangeRelativeDateToDateRelUnitTextViewselectedMessageIdOptionAttrChanged);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.fragmentDateRangeToDateRangeEditText, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, fragmentDateRangeToDateRangeEditTextandroidTextAttrChanged);
            // api target 3
            if(getBuildSdkInt() >= 3) {

                this.fragmentDateRangeFixedDateFromDateTextView.setInputType(android.text.InputType.TYPE_NULL);
                this.fragmentDateRangeFixedDateToDateTextView.setInputType(android.text.InputType.TYPE_NULL);
            }
        }
        if ((dirtyFlags & 0x804L) != 0) {
            // api target 1

            this.fragmentDateRangeFixedDateFromDateTextInputLayout.setError(fromFixedDateMissing);
            this.fragmentDateRangeFixedDateFromDateTextInputLayout.setErrorEnabled(fromFixedDateMissingJavaLangObjectNull);
        }
        if ((dirtyFlags & 0xe01L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTime2(this.fragmentDateRangeFixedDateFromDateTextView, dateRangeMomentFromMomentFixedTime, timeZoneId, androidxDatabindingViewDataBindingSafeUnboxDateTimeMode);
            com.ustadmobile.port.android.view.binding.DatePickerBindingAdapter2Kt.setDateTime2(this.fragmentDateRangeFixedDateToDateTextView, dateRangeMomentToMomentFixedTime, timeZoneId, androidxDatabindingViewDataBindingSafeUnboxDateTimeMode);
        }
        if ((dirtyFlags & 0x880L) != 0) {
            // api target 1

            this.fragmentDateRangeFixedDateToDateTextInputLayout.setError(toFixedDateMissing);
            this.fragmentDateRangeFixedDateToDateTextInputLayout.setErrorEnabled(toFixedDateMissingJavaLangObjectNull);
        }
        if ((dirtyFlags & 0x809L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.fragmentDateRangeRelativeDateFromDateRelTextView, relToOptions, dateRangeMomentFromMomentRelTo);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.fragmentDateRangeRelativeDateToDateRelTextView, relToOptions, dateRangeMomentToMomentRelTo);
        }
        if ((dirtyFlags & 0x821L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.fragmentDateRangeRelativeDateFromDateRelUnitTextView, relUnitOption, dateRangeMomentFromMomentRelUnit);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.fragmentDateRangeRelativeDateToDateRelUnitTextView, relUnitOption, dateRangeMomentToMomentRelUnit);
        }
        if ((dirtyFlags & 0x802L) != 0) {
            // api target 1

            this.fragmentDateRangeToDateRangeInputLayout.setError(toRelativeDateInvalid);
            this.fragmentDateRangeToDateRangeInputLayout.setErrorEnabled(toRelativeDateInvalidJavaLangObjectNull);
        }
    }
    // Listener Stub Implementations
    // callback impls
    public final void _internalCallbackOnClick(int sourceId , android.view.View callbackArg_0) {
        switch(sourceId) {
            case 4: {
                // localize variables for thread safety
                // activityEventHandler != null
                boolean activityEventHandlerJavaLangObjectNull = false;
                // activityEventHandler
                com.ustadmobile.port.android.view.DateRangeFragmentEventHandler activityEventHandler = mActivityEventHandler;



                activityEventHandlerJavaLangObjectNull = (activityEventHandler) != (null);
                if (activityEventHandlerJavaLangObjectNull) {



                    activityEventHandler.onClickRadioSelected(callbackArg_0);
                }
                break;
            }
            case 1: {
                // localize variables for thread safety
                // activityEventHandler != null
                boolean activityEventHandlerJavaLangObjectNull = false;
                // activityEventHandler
                com.ustadmobile.port.android.view.DateRangeFragmentEventHandler activityEventHandler = mActivityEventHandler;



                activityEventHandlerJavaLangObjectNull = (activityEventHandler) != (null);
                if (activityEventHandlerJavaLangObjectNull) {



                    activityEventHandler.onClickRadioSelected(callbackArg_0);
                }
                break;
            }
            case 3: {
                // localize variables for thread safety
                // activityEventHandler != null
                boolean activityEventHandlerJavaLangObjectNull = false;
                // activityEventHandler
                com.ustadmobile.port.android.view.DateRangeFragmentEventHandler activityEventHandler = mActivityEventHandler;



                activityEventHandlerJavaLangObjectNull = (activityEventHandler) != (null);
                if (activityEventHandlerJavaLangObjectNull) {



                    activityEventHandler.onClickRadioSelected(callbackArg_0);
                }
                break;
            }
            case 2: {
                // localize variables for thread safety
                // activityEventHandler != null
                boolean activityEventHandlerJavaLangObjectNull = false;
                // activityEventHandler
                com.ustadmobile.port.android.view.DateRangeFragmentEventHandler activityEventHandler = mActivityEventHandler;



                activityEventHandlerJavaLangObjectNull = (activityEventHandler) != (null);
                if (activityEventHandlerJavaLangObjectNull) {



                    activityEventHandler.onClickRadioSelected(callbackArg_0);
                }
                break;
            }
        }
    }
    // dirty flag
    private  long mDirtyFlags = 0xffffffffffffffffL;
    /* flag mapping
        flag 0 (0x1L): dateRangeMoment
        flag 1 (0x2L): toRelativeDateInvalid
        flag 2 (0x3L): fromFixedDateMissing
        flag 3 (0x4L): relToOptions
        flag 4 (0x5L): loading
        flag 5 (0x6L): relUnitOption
        flag 6 (0x7L): activityEventHandler
        flag 7 (0x8L): toFixedDateMissing
        flag 8 (0x9L): fieldsEnabled
        flag 9 (0xaL): dateTimeMode
        flag 10 (0xbL): timeZoneId
        flag 11 (0xcL): null
        flag 12 (0xdL): dateRangeMoment.fromMoment.typeFlag == Moment.TYPE_FLAG_FIXED ? View.VISIBLE : View.GONE
        flag 13 (0xeL): dateRangeMoment.fromMoment.typeFlag == Moment.TYPE_FLAG_FIXED ? View.VISIBLE : View.GONE
        flag 14 (0xfL): dateRangeMoment.fromMoment.typeFlag == Moment.TYPE_FLAG_RELATIVE ? View.VISIBLE : View.GONE
        flag 15 (0x10L): dateRangeMoment.fromMoment.typeFlag == Moment.TYPE_FLAG_RELATIVE ? View.VISIBLE : View.GONE
        flag 16 (0x11L): dateRangeMoment.toMoment.typeFlag == Moment.TYPE_FLAG_RELATIVE ? View.VISIBLE : View.GONE
        flag 17 (0x12L): dateRangeMoment.toMoment.typeFlag == Moment.TYPE_FLAG_RELATIVE ? View.VISIBLE : View.GONE
        flag 18 (0x13L): dateRangeMoment.toMoment.typeFlag == Moment.TYPE_FLAG_FIXED ? View.VISIBLE : View.GONE
        flag 19 (0x14L): dateRangeMoment.toMoment.typeFlag == Moment.TYPE_FLAG_FIXED ? View.VISIBLE : View.GONE
    flag mapping end*/
    //end
}